# coding: utf-8

"""
    Sedaro API

     Allows for consumption of Sedaro services. Read more about Sedaro at [docs.sedaro.com](https://docs.sedaro.com).  ### Clients  **Python:** [sedaro](https://pypi.org/project/sedaro/) - This package provides additional functionality on top of the auto-generated OpenAPI client. See the package docs for more information.  ### API Key  To access the Sedaro service via this API, you will need an API key.  You can generate an API key for your account in the Sedaro [Management Console](https://satellite.sedaro.com/#/account). Once complete, pass the API key in all requests via the `X_API_KEY` HTTP header.  *API keys grant full access to your account and should never be shared. If you think your API key has been compromised, you can revoke it in the [Management Console](https://satellite.sedaro.com/#/account).*  ### Jupyter Notebooks  For additional examples of how to use this API for modeling and simulation, see our [Mod-Sim Notebooks](https://github.com/sedaro/modsim-notebooks).  ### Community, Support, Discussion  If you have any issues or suggestions, please reach out:  1. Join the Sedaro Community [Slack](https://join.slack.com/t/sedaro-community/shared_invite/zt-1jps4i711-mXy88AZQ9AV7YcEXr8x7Ow) 2. Email us at support@sedarotech.com  ### Known Issues  - Error responses are more specific than what is shown throughout the documentation.  A 4xx or 5xx error will be returned in all error cases.  Only a `200` status indicates success.  See a given error response for additional details.   # noqa: E501

    The version of the OpenAPI document: 4.7.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from sedaro_base_client import schemas  # noqa: F401


class OrbitalElementsData(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        
        class properties:
            a = schemas.NumberSchema
            e = schemas.NumberSchema
            inc = schemas.NumberSchema
            raan = schemas.NumberSchema
            om = schemas.NumberSchema
            nu = schemas.NumberSchema
            eAnom = schemas.NumberSchema
            mAnom = schemas.NumberSchema
            __annotations__ = {
                "a": a,
                "e": e,
                "inc": inc,
                "raan": raan,
                "om": om,
                "nu": nu,
                "eAnom": eAnom,
                "mAnom": mAnom,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["a"]) -> MetaOapg.properties.a: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["e"]) -> MetaOapg.properties.e: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["inc"]) -> MetaOapg.properties.inc: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["raan"]) -> MetaOapg.properties.raan: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["om"]) -> MetaOapg.properties.om: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["nu"]) -> MetaOapg.properties.nu: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["eAnom"]) -> MetaOapg.properties.eAnom: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["mAnom"]) -> MetaOapg.properties.mAnom: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["a", "e", "inc", "raan", "om", "nu", "eAnom", "mAnom", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["a"]) -> typing.Union[MetaOapg.properties.a, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["e"]) -> typing.Union[MetaOapg.properties.e, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["inc"]) -> typing.Union[MetaOapg.properties.inc, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["raan"]) -> typing.Union[MetaOapg.properties.raan, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["om"]) -> typing.Union[MetaOapg.properties.om, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["nu"]) -> typing.Union[MetaOapg.properties.nu, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["eAnom"]) -> typing.Union[MetaOapg.properties.eAnom, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["mAnom"]) -> typing.Union[MetaOapg.properties.mAnom, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["a", "e", "inc", "raan", "om", "nu", "eAnom", "mAnom", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        a: typing.Union[MetaOapg.properties.a, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        e: typing.Union[MetaOapg.properties.e, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        inc: typing.Union[MetaOapg.properties.inc, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        raan: typing.Union[MetaOapg.properties.raan, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        om: typing.Union[MetaOapg.properties.om, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        nu: typing.Union[MetaOapg.properties.nu, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        eAnom: typing.Union[MetaOapg.properties.eAnom, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        mAnom: typing.Union[MetaOapg.properties.mAnom, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'OrbitalElementsData':
        return super().__new__(
            cls,
            *_args,
            a=a,
            e=e,
            inc=inc,
            raan=raan,
            om=om,
            nu=nu,
            eAnom=eAnom,
            mAnom=mAnom,
            _configuration=_configuration,
            **kwargs,
        )
