# coding: utf-8

"""
    Sedaro API

     Allows for consumption of Sedaro services. Read more about Sedaro at [docs.sedaro.com](https://docs.sedaro.com).  ### Clients  **Python:** [sedaro](https://pypi.org/project/sedaro/) - This package provides additional functionality on top of the auto-generated OpenAPI client. See the package docs for more information.  ### API Key  To access the Sedaro service via this API, you will need an API key.  You can generate an API key for your account in the Sedaro [Management Console](https://satellite.sedaro.com/#/account). Once complete, pass the API key in all requests via the `X_API_KEY` HTTP header.  *API keys grant full access to your account and should never be shared. If you think your API key has been compromised, you can revoke it in the [Management Console](https://satellite.sedaro.com/#/account).*  ### Jupyter Notebooks  For additional examples of how to use this API for modeling and simulation, see our [Mod-Sim Notebooks](https://github.com/sedaro/modsim-notebooks).  ### Community, Support, Discussion  If you have any issues or suggestions, please reach out:  1. Join the Sedaro Community [Slack](https://join.slack.com/t/sedaro-community/shared_invite/zt-1jps4i711-mXy88AZQ9AV7YcEXr8x7Ow) 2. Email us at support@sedarotech.com  ### Known Issues  - Error responses are more specific than what is shown throughout the documentation.  A 4xx or 5xx error will be returned in all error cases.  Only a `200` status indicates success.  See a given error response for additional details.   # noqa: E501

    The version of the OpenAPI document: 4.7.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from sedaro_base_client import schemas  # noqa: F401


class ThermalDesignLayout(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    A ThermalDesignLayout Block
    """


    class MetaOapg:
        required = {
            "lastUsed",
            "dateCreated",
            "name",
            "lastEdited",
        }
        
        class properties:
            
            
            class name(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    max_length = 25
                    min_length = 2
            dateCreated = schemas.NumberSchema
            lastEdited = schemas.NumberSchema
            lastUsed = schemas.NumberSchema
            id = schemas.StrSchema
            nodes = schemas.DictSchema
            
            
            class type(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "ThermalDesignLayout": "THERMAL_DESIGN_LAYOUT",
                    }
                
                @schemas.classproperty
                def THERMAL_DESIGN_LAYOUT(cls):
                    return cls("ThermalDesignLayout")
            __annotations__ = {
                "name": name,
                "dateCreated": dateCreated,
                "lastEdited": lastEdited,
                "lastUsed": lastUsed,
                "id": id,
                "nodes": nodes,
                "type": type,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    lastUsed: MetaOapg.properties.lastUsed
    dateCreated: MetaOapg.properties.dateCreated
    name: MetaOapg.properties.name
    lastEdited: MetaOapg.properties.lastEdited
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["lastUsed"]) -> MetaOapg.properties.lastUsed: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dateCreated"]) -> MetaOapg.properties.dateCreated: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["lastEdited"]) -> MetaOapg.properties.lastEdited: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["nodes"]) -> MetaOapg.properties.nodes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["lastUsed"], typing_extensions.Literal["dateCreated"], typing_extensions.Literal["name"], typing_extensions.Literal["lastEdited"], typing_extensions.Literal["id"], typing_extensions.Literal["nodes"], typing_extensions.Literal["type"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["lastUsed"]) -> MetaOapg.properties.lastUsed: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dateCreated"]) -> MetaOapg.properties.dateCreated: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["lastEdited"]) -> MetaOapg.properties.lastEdited: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["nodes"]) -> typing.Union[MetaOapg.properties.nodes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> typing.Union[MetaOapg.properties.type, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["lastUsed"], typing_extensions.Literal["dateCreated"], typing_extensions.Literal["name"], typing_extensions.Literal["lastEdited"], typing_extensions.Literal["id"], typing_extensions.Literal["nodes"], typing_extensions.Literal["type"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        lastUsed: typing.Union[MetaOapg.properties.lastUsed, decimal.Decimal, int, float, ],
        dateCreated: typing.Union[MetaOapg.properties.dateCreated, decimal.Decimal, int, float, ],
        name: typing.Union[MetaOapg.properties.name, str, ],
        lastEdited: typing.Union[MetaOapg.properties.lastEdited, decimal.Decimal, int, float, ],
        id: typing.Union[MetaOapg.properties.id, str, schemas.Unset] = schemas.unset,
        nodes: typing.Union[MetaOapg.properties.nodes, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        type: typing.Union[MetaOapg.properties.type, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'ThermalDesignLayout':
        return super().__new__(
            cls,
            *_args,
            lastUsed=lastUsed,
            dateCreated=dateCreated,
            name=name,
            lastEdited=lastEdited,
            id=id,
            nodes=nodes,
            type=type,
            _configuration=_configuration,
        )
